#include "header\GBA.h"
#include "header\BG.h"
#include "header\Timer.h"
#include "header\DMA.h"
#include "header\IRQ.h"
#include "header\sound.h"
#include "header\sprite.h"

#include "lib.h"
#include "iwram.h"
#include "irq.h"
#include "syscall.h"

#include "data.h"
#include "resource\BitMapFont.h"

#include <stdlib.h> 

//const int __gba_multiboot;  //GBANp

#define FILED_X 120
#define FILED_Y 2
#define FILED_CARD_CX 4
#define FILED_CARD_CY 4
#define FILED_CARD_CNT (FILED_CARD_CX * FILED_CARD_CY)

#define CARD_URA    52	//ʕ\
#define CARD_SELECT 53	//ZNg\
//---------------------------------------------------------------------------
typedef struct {
	u16 cx;
	u16 cy;
	u16 BmpCx;
	u16 BmpCy;
	u16 NextMark;
	u16 NextPaint;
} ST_CARD;

ST_CARD CARD;

u8 CardVal [FILED_CARD_CNT];
u8 CardView[FILED_CARD_CNT];	//\tO
u8 CardLook[FILED_CARD_CNT];	//Rs[^ptO
u8 CardCnt;

u8 Turn;
u8 ScrPly;	//XRA
u8 ScrCom;
//---------------------------------------------------------------------------
void Init();
void Title();
void TurnPlayer();
void TurnComputer();
void Shuffle();

void DispCard(u8,u8);
void DispField();
void DispScore();
void DispWinner();

void WaitPushA();
void Wait500ms();

u8 GetPlayerSelectCard();
u8 GetComputerSelectCard();
u8 GetNextEnableDispCardNumber(u8,u8);
//---------------------------------------------------------------------------
int main(void)
{
	Mode3SetBitMapFont((u8*)BitMapFont, 8,8,0);
	Mode3DrawBitMapStr(1,17,"SinkeiSuijakuPlus Sample. --");
	Mode3DrawBitMapStr(1,18,"2005/05/04 by Akkera.    ---");
	SetMode(MODE_3 | BG2_ENABLE);

	Title();	//擾p

	Init();
	//Shuffle();
	DispField();

	while(CardCnt > 0){
		Turn++;
		TurnPlayer();
		TurnComputer();
	}

	DispWinner();
	for(;;){}

	return 0;
}
//---------------------------------------------------------------------------
void Title(){
	REG_TM0CNT = 0x00C0; //_p

	Mode3DrawBitMapStr(1,1,"Push A Button");
	WaitPushA();
	Mode3DrawBitMapStr(1,1,"             ");

	REG_TM0CNT = 0x0000; //
	srand(REG_TM0D);
}
//---------------------------------------------------------------------------
void Init(){

	CardCnt = FILED_CARD_CNT;
	Turn    = 0;
	ScrPly  = 0;

	CARD.cx        = 24;
	CARD.cy        = 32;
	CARD.BmpCx     = 312;
	CARD.BmpCy     = 160;
	CARD.NextMark  = CARD.BmpCx * CARD.cy;
	CARD.NextPaint = CARD.BmpCx - CARD.cx;

	int i;
	for(i=0; i<FILED_CARD_CNT; i++){
		CardView[i] = 0;
		CardLook[i] = 0;
	}

	//J[h̏l
	for(i=0; i<FILED_CARD_CNT/2; i++){
		CardVal[i]                  = i;
		CardVal[i+FILED_CARD_CNT/2] = i+26;
	}
}
//---------------------------------------------------------------------------
void Shuffle(){
	int i;
	u8 ct,cr1,cr2;

	for(i=0; i<FILED_CARD_CNT*2; i++){
		cr1 = i      % FILED_CARD_CNT;
		cr2 = rand() % FILED_CARD_CNT;

		if(cr1 == cr2)
			continue;

		ct = CardVal[cr1];
		CardVal[cr1] = CardVal[cr2];
		CardVal[cr2] = ct;
	}
}
//---------------------------------------------------------------------------
u8 GetPlayerSelectCard(){
	u32 KeyPrev = 0;
	u32 KeyNew  = 0;
    u32 KeyLate = 0;
	u8  Select  = 0;

	Select = GetNextEnableDispCardNumber(Select,' ');
	DispCard(Select, CARD_SELECT);

	for(;;){

		//O񉟂ĂȂǁA񉟂ꂽ̂擾
		WaitForVsync();

		KeyPrev = KeyNew;
		KeyNew  = *KEYS  ^ 0x3ff;
		KeyLate = KeyNew ^ (KeyPrev & KeyNew);

		if( KeyLate & KEY_A )
			break;

		if( KeyLate & KEY_LEFT ){
				DispCard(Select, CARD_URA);
				Select = GetNextEnableDispCardNumber(Select,'-');
				DispCard(Select, CARD_SELECT);
		}
		if( KeyLate & KEY_RIGHT ){
				DispCard(Select, CARD_URA);
				Select = GetNextEnableDispCardNumber(Select,'+');
				DispCard(Select, CARD_SELECT);
		}

	}//for(;;)

	DispCard(Select, CardVal[Select]);
	CardView[Select] = 1;
	CardLook[Select] = 1;
	WaitPushA();

	return Select;
}
//---------------------------------------------------------------------------
void TurnPlayer(){
	u8 SelCard1, SelCard2;
	u8 ValCard1, ValCard2;

RePlay:
	DispScore();

	if(CardCnt <= 0)
		return;

	SelCard1 = GetPlayerSelectCard();
	SelCard2 = GetPlayerSelectCard();
	ValCard1 = CardVal[SelCard1];
	ValCard2 = CardVal[SelCard2];

	Wait500ms();

	//
	if(ValCard1%13 == ValCard2%13){
		ScrPly++;	//`
		CardCnt-=2;
		goto RePlay;
	}
	
	//O`
	DispCard(SelCard1, CARD_URA);
	DispCard(SelCard2, CARD_URA);
	CardView[SelCard1] = 0;
	CardView[SelCard2] = 0;
}
//---------------------------------------------------------------------------
//݂̃J[hʒuAZNg\ȃJ[hʒuĂ
u8 GetNextEnableDispCardNumber(u8 num,u8 mark){
	s8 i,each;
	
	switch(mark){
		case '+': i=num+1; each= 1; break;
		case '-': i=num-1; each=-1; break;
		default : i=num  ; each= 1; break;
	}

	if(i<0) i=FILED_CARD_CNT-1;
	if(i>FILED_CARD_CNT-1) i=0;

	while(CardView[i]){
		dprintf("i=0x%x\n",i);
		i+=each;

		if(i<0) i=FILED_CARD_CNT-1;
		if(i>FILED_CARD_CNT-1) i=0;
	}
	return i;
}
//---------------------------------------------------------------------------
void TurnComputer(){
	u8 SelCard1, SelCard2;
	u8 ValCard1, ValCard2;
	u8 i,j;

ReCom:
	DispScore();

	if(CardCnt <= 0)
		return;

	//߂J[h̒ɃyAH
	for(i=0; i<FILED_CARD_CNT; i++){
		for(j=0; j<FILED_CARD_CNT; j++){
			if(i != j){
				if(CardLook[i] && CardLook[j]){
					if(!CardView[i] && !CardView[j]){
						if(CardVal[i]%13 == CardVal[j]%13){

							//
							DispCard(i, CardVal[i]);
							DispCard(j, CardVal[j]);
							CardView[i] = 1;
							CardView[j] = 1;
							ScrCom++;
							CardCnt-=2;

							Wait500ms();
							goto ReCom;
						}
					}
				}
			}
		}
	}

	for(;;){
		SelCard1 = GetNextEnableDispCardNumber(rand()%FILED_CARD_CNT,'+');
		SelCard2 = GetNextEnableDispCardNumber(rand()%FILED_CARD_CNT,'+');

		if(SelCard1 != SelCard2)
			break;
	}

	DispCard(SelCard1, CardVal[SelCard1]);
	DispCard(SelCard2, CardVal[SelCard2]);
	CardView[SelCard1] = 1;
	CardView[SelCard2] = 1;
	CardLook[SelCard1] = 1;
	CardLook[SelCard2] = 1;

	ValCard1 = CardVal[SelCard1];
	ValCard2 = CardVal[SelCard2];

	Wait500ms();

	//
	if(ValCard1%13 == ValCard2%13){
		ScrCom++;
		CardCnt-=2;
		goto ReCom;
	}
	
	//O`
	DispCard(SelCard1, CARD_URA);
	DispCard(SelCard2, CARD_URA);
	CardView[SelCard1] = 0;
	CardView[SelCard2] = 0;
}
//---------------------------------------------------------------------------
void DispField(){
	u8 i;
	for(i=0; i<FILED_CARD_CNT; i++){
		if(CardView[i]) DispCard(i,CardVal[i]);
		else            DispCard(i,CARD_URA);
	}
}
//---------------------------------------------------------------------------
//\@P̃J[h
void DispCard(u8 select, u8 val){
	u16 *Card   = (u16*)EtfsGetDataOffset(_CARD_IMG_BIN_OFFSET);
	u16 *Screen = VideoBuffer;
	u8 x,y;
	u8 i,j;

	Card += (val/13)*CARD.NextMark;
	Card += (val%13)*CARD.cx;

	x = (select % FILED_CARD_CX) * CARD.cx + FILED_X;
	y = (select / FILED_CARD_CY) * CARD.cy + FILED_Y;
	Screen += y*240+x;

	for(i=0; i<CARD.cy; i++){
		for(j=0; j<CARD.cx; j++){
			Screen[i*240+j] = *Card++;
		}
		Card += CARD.NextPaint;
	}
}
//---------------------------------------------------------------------------
void DispScore(){
	char buf[32];

	bprintf(buf, "Turn   :%2d",Turn);
	Mode3DrawBitMapStr(1,1,buf);
	bprintf(buf, "PlayScr:%2d",ScrPly);
	Mode3DrawBitMapStr(1,3,buf);
	bprintf(buf, "ComScr :%2d",ScrCom);
	Mode3DrawBitMapStr(1,4,buf);
}
//---------------------------------------------------------------------------
void DispWinner(){
	char buf[32];

	if(ScrPly >  ScrCom) bprintf(buf, "Player   WIN!!");
	if(ScrPly <  ScrCom) bprintf(buf, "Computer WIN!!");
	if(ScrPly == ScrCom) bprintf(buf, "Oops...   Draw");
	Mode3DrawBitMapStr(1,6,buf);
}
//---------------------------------------------------------------------------
void WaitPushA(){
	while(   *KEYS & KEY_A  ){}
	while( !(*KEYS & KEY_A) ){}
}
//---------------------------------------------------------------------------
void Wait500ms(){
	REG_TM0D = 0;
	REG_TM0CNT = TM_FREQ_PER_256 | TM_ENABLE;

	while(REG_TM0D < 0x8000){
		Mode3DrawBitMapStr(1,1,""); //gcc̍œK̂߂ɏȂ݂
									//Ȃ̂ŁAeLg[ȏƂ
	}

	REG_TM0CNT = TM_DISABLE;
	REG_TM0D = 0;
}
//---------------------------------------------------------------------------
